#include<stdio.h>
#include<math.h>

int main(){

  int i;
  double x, h, diff3, diff5, diff7, diff9;

  double f(double);
  double dfdx(double);

  /* xに1を代入、x=1でのdf/dxの値を表示 */
  x = 1.0;
  printf("Analytic solution of df/dx: %f\n", dfdx(x));

  /* 表の見出しを出力 */
  printf("        h             3-point         5-point         7-point          9-point\n");

  /* hの値をfor文で0.1倍ずつして小さくする */
  for(h=0.1; h>pow(10.0,-8); h/=10){

    /* 3点、5点、7点、9点公式 */
    diff3 = ( -f(x-h)+ f(x+h) )/(2.0*h); 
    diff5 = ( f(x-2*h)-8.0*f(x-h)+ 8.0*f(x+h)-f(x+2*h) )/(12.0*h);
    diff7 = ( -f(x-3*h)+ 9.0*f(x-2*h)-45.0*f(x-h)+ 45.0*f(x+h)
	      -9.0*f(x+2*h)+f(x+3.0*h) )/(60.0*h);
    diff9 = ( 3.0*f(x-4*h)-32.0*f(x-3*h)+168.0*f(x-2*h)-672.0*f(x-h)+672.0*f(x+h)
	      -168.0*f(x+2*h)+32.0*f(x+3.0*h)-3.0*f(x+4*h) )/(840.0*h);

    /* 結果の出力 %eは実数の指数表示*/
    printf("%15.5e %15.5e %15.5e %15.5e %15.5e\n", h, fabs(diff3-dfdx(x)), fabs(diff5-dfdx(x)), fabs(diff7-dfdx(x)), fabs(diff9-dfdx(x)));  
  }

  return 0;
    
}

double f(double x){
  return(sin(x));
}

double dfdx(double x){
  return(cos(x));
}
