#include<stdio.h>
#include<math.h>

int main(){

  double xleg[8], wleg[8]; /* xlegはLegendre多項式のゼロ点、wlegがゼロ点での重み */
  int i, nleg;
  double integral;

  double f(double);

  for(nleg = 2; nleg<9; nleg+=2){

    /* それぞれのnlegに対するゼロ点と重み */
    if (nleg==2){
      wleg[0]=1.0000000000000000;xleg[0]=0.5773502691896257;
      wleg[1] = wleg[0]; xleg[1] = -xleg[0];
    } else if( nleg==4){
      wleg[0]=0.6521451548625461;xleg[0]=0.3399810435848563;
      wleg[1]=0.3478548451374538;xleg[1]=0.8611363115940526;
      wleg[2] = wleg[0]; xleg[2] = -xleg[0];
      wleg[3] = wleg[1]; xleg[3] = -xleg[1];
    } else if ( nleg == 6){
      wleg[0]=0.3607615730481386; xleg[0]=0.6612093864662645;
      wleg[1]=0.4679139345726910; xleg[1]=0.2386191860831969;
      wleg[2]=0.1713244923791704; xleg[2]=0.9324695142031521;
      wleg[3] = wleg[0]; xleg[3] = -xleg[0];
      wleg[4] = wleg[1]; xleg[4] = -xleg[1];
      wleg[5] = wleg[2]; xleg[5] = -xleg[2];
    } else if ( nleg == 8) {
      wleg[0]=0.3626837833783620;xleg[0]=0.1834346424956498;
      wleg[1]=0.3137066458778873;xleg[1]=0.5255324099163290;
      wleg[2]=0.2223810344533745;xleg[2]=0.7966664774136267;
      wleg[3]=0.1012285362903763;xleg[3]=0.9602898564975363;
      wleg[4] = wleg[0]; xleg[4] = -xleg[0];
      wleg[5] = wleg[1]; xleg[5] = -xleg[1];
      wleg[6] = wleg[2]; xleg[6] = -xleg[2];
      wleg[7] = wleg[3]; xleg[7] = -xleg[3];
    }

    /* 積分の初期化 */
    integral = 0.0;

    /* Gauss-Legendre公式は積分区間を[-1,1]に変換してから用いる */
    for(i=0;i<nleg;i++){
      integral += 0.50*wleg[i]*f(0.50*xleg[i]+0.5);
    }

    /* 結果の出力 */
    printf("nleg = %d, %15.5e\n", nleg, fabs(integral - log(2.0)));

  }

  return 0;
  
}

double f(double x){
  return( 1.0/(1.0+x));
}
